static char *cvs_id =" $Id: bm2img.c,v 1.13 2003/09/22 09:52:04 berar Exp $ ";
/*  xy_hdr : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr                          */
/*  ------------------------------------------------ */
/*  04may98  stabilised for .spe files               */
/*  09mar00  xy_excl.c seems ok for triangles        */
/*  29mar00  xy_rep_name + xy_cur_name cf xy2ph.c    */
/*  xxoct02  xy_grid.c ,related grid functionality   */
/*  xxfeb03  xy_orien.c, grid depends on reading noise  */
/*  xxsep03  bm2img.c, force cosmicsum corrected after get  */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#include "prg_def.h"

#include "xy_def.h"
#include "bm_def.h"

#include "wv_def.h"
#include "gel_def.h"
#include "edf_def.h"
#include "txt_def.h"
#include "dmi_def.h"
#include "7c_def.h"
#include "release.h"
#define FREE(a)    free(a); a=NULL;
/*-----------------------------------------------------------*/
#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h> 
#endif
/*-----------------------------------------------------------*/
#define TITLE " extracting info/preprocessing image"
#define REFERENCE "berar@esrf.fr (d2am), "
/* default values */
/*-----------------------------------------------------------*/
/* declarations globales */
char     *prg_name;
char     *r_def = NULL;
char     *w_def = NULL;
IMAGE   image, i_image, d_image, f_image;
T_DATA t_mode = INVALID_DATA;
float  sca_dark      = 1.0;
int    add_dark    = 0;
int    set_limit = 0;
float  low_limit = -1.0/0.0;
int    dformat     = 0;
int    print       = 7;
int    real_time   = 0;
int    grid_done  = 0;
INT32  *i_value   = NULL;
INT32  *d_value   = NULL;
INT32  *f_value   = NULL;
char   *i_name    = NULL;
char   *d_name    = NULL;
char   *f_name    = NULL;
char   *g_name    = NULL;
char   *o_cosmic  = NULL;
char   *grid_auto = NULL;
char   *dir = NULL;
char   *out = NULL;
#define BUFSIZE 500                   /* to read grid lines */
char   buffer[BUFSIZE+1];
double  scale_det[4] = { 1, 0, 0, 1}; 
double  orig_det[2] = { 0, 0}; 
FILE   *redir;
FILE   *out_cosmic = NULL;
FILE   *spec = NULL;
char    *spec_name = NULL;
char    *wspec2xl = NULL;
int    xl_col = 0;
#if defined ( __STDC__ ) || defined ( MAC_OS )
static time_t secs_now;
#else
static long   secs_now;
#endif
char  *str_time;
/*-----------------------------------------------------------*/
/* used in specific external routines */
int   cr_mode = 0;
float ahkl, bhkl, chkl, dhkl, ehkl;
/*-----------------------------------------------------------*/
void  usage( char *name, char *why);
void  parameter( FILE * f_ini);
void  get_image( char *name, char *path, IMAGE *img);
void  put_image( char *name, char *path, IMAGE *img);
void  mul_image( char *name, IMAGE *img);
void  add_image( char *name, IMAGE *img);
void  cut_image( char *name, IMAGE *img);
void  sca_image( char *name, IMAGE *img);
void  grid_image( char *name, IMAGE *img);
void  proc_image( IMAGE *img);
double spec2xl( char * name, IMAGE *img);
INT32 *cor_image( IMAGE *img);
/*-----------------------------------------------------------*/
void usage( char *name, char *why)
{
/*  fprintf(stderr, "usage : %s [D=|F=]img_file[,Bb,Ee,X,Aa|Mm,Uu,Tt,Ss] [img...] [%%M=val] [%%[X] [img...]]\n\ */
  fprintf(stderr, "usage : %s [D=|F=]img_file[,Bb,Ee,X,Aa|Mm,Uu] [img...] [%%M=val] [%%[X] [img...]]\n\
   example D=dark3,B2,A5  add frame starting at 2 in dark_files dark3 to dark8, U force used frames to u\n\
   D=dark_file to substract, F=flatfield_file (must be defined before image\n\
   Begin at frame b, End at frame e, X don't correct\n\
   Add a files with increasing number (or Merge them, DMI specific)\n\
   Inside the program the image are kept as integer with 32 bits\n\
   %%M=val (%%A=val) multiply current image by val (or add to) before reading next arguments\n\
        val can be expressed as %%M=1.0e6/SPEC (call wspec2xl.pl ... to get real value)\n\
   %%C=vah[,val] cut counts higher (lower) than vah*mean before reading next arguments\n\
   %%S=val rescalling dynamics to val\n\
   %%X[[name].edf|.gel|.tif|.txt] produces outfile (edf default with 32bits integers)\n\
   %%Y[[name].edf|.gel|.tif|.txt] produces 16bits outfile (gel default) rescalling the output if mandatory\n\
   %%Z[[name].edf|.gel|.tif|.txt] produces 8bits outfile (tif default)  rescalling the output if mandatory\n\
   %%R produce radial distribution file (.rad), one angular sector is the default\n\
   %%P[=m[,o],v]]] produce peak list file (.pks), m=5 peaks is the default, omega osc if not 0, sum>v*max, v=1.5\n\
   %%H produce an ascii map (h, k, l) of the file  using the UB matrix\n\
   %%F clean current image (but keeps dark and flat)\n\
   %%G apply grid correction as defined by GRID_DCOR, GRID_XCOR, GRID_YCOR in ini file (see bm2grid)\n\
   %%g=[[name].edf|.gel|.tif|.txt]= produces a mask file (grid corrected) to be used by F_EXCLUDED\n\
   %%T=\"rule\" transform according rule\n\
   a specific statistic routine is called when the program name contains the string 'stat'\n\
   previous keys are not valid in this case \n\
   see also prameters in %s.ini file\n\n", prg_name, prg_name );
   fprintf (stderr, "Look at bm2img.pdf (if available) or try %s --usage[=grid,radial,mask,spec,cosmic,crystal,other,stat] \n",
   prg_name, prg_name);
   if ( name && strlen(name)) fprintf (stderr, "%s\n", name);
   if ( why==NULL || !strstr(why,"--usage")) exit(3);
   fprintf(stderr, "\nUsing : %s %s \n", prg_name, why);
   fprintf(stderr, "\nValid options in %s.ini files are : \n", name);
   if ( !strstr(why,"--usage=") || strstr(why,"other")) 
   {  prg_iniuse(name);
     xy_iniuse();
     fprintf(stderr, " DIR = full path to search for data file\n");
     fprintf(stderr, " OUT = full path for result (.res) file\n");
     fprintf(stderr, " DEF = default file extension :'.gel' or 'gel' (if not default according prg_name : spe2img, edf2img, gel2img)\n");
     fprintf(stderr, " CR = 0, set to 1 if you wish cr in rad file\n");
     fprintf(stderr, " DFORMAT = size of ineger field in output name, default same as entry\n");
     fprintf(stderr, " STDIN = full path for redirecting stdin\n");
     fprintf(stderr, " FLAT_NAME = full path of the flatfield file to use\n");
     fprintf(stderr, " DARK_NAME = full path of the dark file to use\n");
     fprintf(stderr, " SCA_DARK = scale factor to apply on dark\n");
     fprintf(stderr, " ADD_DARK = offset to add to dark curent\n");
     fprintf(stderr, " SET_LIMIT = remove values lower than LOW_LIMIT if not zero\n");
     fprintf(stderr, " LOW_LIMIT = values are replaced mean of surrounding values (SET_LIMIT=1), by LOW_LIMIT (SET_LIMIT=2)\n");
     fprintf(stderr, " ADD_DARK = offset to add to dark curent\n");
     fprintf(stderr, " REALTIME = 0 or waiting time in secs to ensure data completion\n");
     fprintf(stderr, " PRINT   = ... +64 cosmics, +128 cor, +256 sum, +512 raw\n");
     fprintf(stderr, " T_DATA  = output mode (float...) for edf file\n");
     fprintf(stderr, " SCALE =  scal_xx(=1) scal_xy(=0) scal_yx(=0) scal_yy(=1) matrix form pixel to detector\n");
     }
   if ( !strstr(why,"--usage=") || strstr(why,"crystal")) 
   {  prg_iniuse(name);
     xy_iniuse();
     fprintf(stderr, " ORIG =  pixel_x(=0) pixel_y(=0) center of detector \n");
     fprintf(stderr, " MAT_UB = values according spec\n");
     fprintf(stderr, " LAMBDA = 1 (if not given)\n");
     fprintf(stderr, " GONIO =  0.00 th chi phi\n");
     fprintf(stderr, " DETEC =  alpha tth Rx(=1) Ry(=0) Rz(=0)\n");
     fprintf(stderr, " SCALE =  scal_xx(=1) scal_xy(=0) scal_yx(=0) scal_yy(=1) matrix form pixel to detector\n");
     fprintf(stderr, " PLANE = a x+ b y+ c z= d  e ecart \n");
     }
   if ( !strstr(why,"--usage=") || strstr(why,"mask")) 
   {  fprintf(stderr, " C_ROI = x1 y1 r [QUIET]\n");
     fprintf(stderr, " R_ROI = x1 y1 x2 y2 [QUIET]\n");
     fprintf(stderr, " P_EXCLUDED = x1 y1 [v] [QUIET]\n");
     fprintf(stderr, " C_EXCLUDED = x1 y1 r [v] [QUIET]\n");
     fprintf(stderr, " R_EXCLUDED = x1 y1 x2 y2 [v] [QUIET]\n");
     fprintf(stderr, " T_EXCLUDED = x1 y1 x2 y2 x3 y3 [v] [QUIET]\n");
     fprintf(stderr, " F_EXCLUDED = mask_file_name\n");
     fprintf(stderr, " ROI(s) are added together before all excluding zone");
     }
   if ( !strstr(why,"--usage=") || strstr(why,"spec")) 
   {  fprintf(stderr, " SPEC = full path to spec file for collecting info\n");
     fprintf(stderr, " WSPEC2XL = script (and args) to extract normation, use * for file name \n");
     fprintf(stderr, " XL_COL = pos of the selected column in WSPEC2XL\n");
     }
   if ( !strstr(why,"--usage=") || strstr(why,"cosmic")) 
   {  fprintf(stderr, " O_COSMIC = file_name, STDOUT or default to image_name.cosmic\n");
     fprintf(stderr, " T_COSMIC = used for time removal\n");
     fprintf(stderr, " S_COSMIC = used for space removal\n");
     fprintf(stderr, " R_COSMIC = ratio on the standard deviation used for time and space removal\n");
     fprintf(stderr, " H_COSMIC = lower cosmics on one frame for time removal\n");
     fprintf(stderr, " P_COSMIC = lower cosmics on the frame sum for spacial removal\n");
     }
   if ( !strstr(why,"--usage=") || strstr(why,"grid"))   grid_usage();
   if ( !strstr(why,"--usage=") || strstr(why,"radial")) use_radial();
   if ( strstr(prg_name, "stat") )  use_stat( );
   fprintf(stderr,"\n");
   exit(0);
   }
/*-----------------------------------------------------------*/
void parameter( FILE *f_ini)
{   char *d, *e;
    char *tag, *arg;
    char *stdin_name = NULL;
    while (!feof(f_ini))
    {   fgets(buffer, sizeof(buffer)-1, f_ini);
        if (feof(f_ini)) break;
        d = buffer;
        if ( prg_initag(d, &tag, &arg) == 0 ) continue;
        if ( xy_inipar(&image, tag, arg)) continue;
        if ( prg_inistr(tag, arg, "FLAT_NAME", &f_name) ) continue;
        if ( prg_inistr(tag, arg, "DARK_NAME", &d_name)) continue;
        if ( prg_inistr(tag, arg, "DIR", &dir)) continue;
        if ( prg_inistr(tag, arg, "OUT", &out)) continue;
        if ( prg_inistr(tag, arg, "DEF", &r_def)) continue;
        if ( prg_iniint(tag, arg, "CR", &cr_mode)) continue;
        if ( prg_iniint(tag, arg, "DFORMAT", &dformat)) continue;
        if ( prg_inistr(tag, arg, "STDIN", &stdin_name)) continue;
        if ( prg_inistr(tag, arg, "SPEC",     &spec_name)) continue;
        if ( prg_inistr(tag, arg, "WSPEC2XL", &wspec2xl)) continue;
        if ( prg_iniint(tag, arg, "XL_COL",   &xl_col)) continue;
        if ( prg_inistr(tag, arg, "O_COSMIC", &o_cosmic)) continue;
        if ( prg_iniflt(tag, arg, "T_COSMIC", &image.cosmic.time)) continue;
        if ( prg_iniflt(tag, arg, "S_COSMIC", &image.cosmic.space)) continue;
        if ( prg_iniflt(tag, arg, "R_COSMIC", &image.cosmic.ratio)) continue;
        if ( prg_iniflt(tag, arg, "H_COSMIC", &image.cosmic.t_height)) continue;
        if ( prg_iniflt(tag, arg, "P_COSMIC", &image.cosmic.s_height)) continue;
        if ( prg_iniflt(tag, arg, "SCA_DARK", &sca_dark)) continue;
        if ( prg_iniint(tag, arg, "ADD_DARK", &add_dark)) continue;
        if ( prg_iniflt(tag, arg, "LOW_LIMIT", &low_limit)) continue;
        if ( prg_iniint(tag, arg, "SET_LIMIT", &set_limit)) continue;
        if ( prg_iniint(tag, arg, "REALTIME",  &real_time)) continue;
        if ( prg_iniint(tag, arg, "PRINT", &print)) continue;
        if ( strcmp(tag, "T_DATA") == 0 )
        {   if (strstr(arg, "T_INT32") )  t_mode = T_INT32;
  	         else if (strstr(arg, "T_FLOAT") )  t_mode = T_FLOAT;
  	         else 
  	         {   prg_printf(" invalid %s mode in T_DATA, reset to INVALID_DATA\n", arg);
  	             t_mode = INVALID_DATA; d = "INVALID_DATA";
  	             }
  	         prg_printf(" T_DATA= %s\n", arg);
            continue;
				}
       if ( prg_iniint ( tag, arg, "SPEC_UB", &spec_ub)) continue;
       if ( prg_inidbln( tag, arg, "MAT_UB", &mat_ub.t[0], 9)) continue;
       if ( prg_inidbln( tag, arg, "LAMBDA", &lambda, 1)) continue;
       if ( prg_inidbln( tag, arg, "GONIO", &goniometer.angle[0], 4)) continue;
       if ( prg_inidbln( tag, arg, "DETEC", &goniometer.angle[4], 5)) continue;
       if ( prg_inidbln( tag, arg, "SCALE", scale_det, 4)) continue;
       if ( prg_inidbln( tag, arg, "ORIG", orig_det, 2)) continue;
       if ( prg_inistr( tag, arg, "GRID_AUTO", &grid_auto)) continue;
		 if ( grid_ini(&grid_cor, tag, arg)) continue;
		 if ( ini_radial(tag, arg)) continue;
       if (strcmp(tag, "PLANE") == 0 )
       {   sscanf(arg,"%f%f%f%f%f", &ahkl, &bhkl, &chkl, &dhkl, &ehkl);
           prg_printf(" PLANE= abs(%f H + %f K +%f L + %f) < %f\n", ahkl, bhkl, chkl, dhkl, ehkl);
			  continue;
          }
       
       if (strcmp(tag, "P_EXCLUDED") == 0 )  { excl_ini( P_EXCL, arg ); continue; }
       if (strcmp(tag, "C_EXCLUDED") == 0 )  { excl_ini( C_EXCL, arg ); continue; }
       if (strcmp(tag, "R_EXCLUDED") == 0 )  { excl_ini( R_EXCL, arg ); continue; }
       if (strcmp(tag, "T_EXCLUDED") == 0 )  { excl_ini( T_EXCL, arg ); continue; }
       if (strcmp(tag, "F_EXCLUDED") == 0 )  { excl_ini( F_EXCL, arg ); continue; }
       if (strcmp(tag, "C_ROI") == 0 )  { excl_ini( C_EXCL+ROI, arg ); continue; }
       if (strcmp(tag, "R_ROI") == 0 )  { excl_ini( R_EXCL+ROI, arg ); continue; }
       if (strcmp(tag, "T_ROI") == 0 )  { excl_ini( T_EXCL+ROI, arg ); continue; }

   	 if ( strstr(prg_name, "stat") )  par_stat( tag, arg); 

       }
	if (stdin_name) 
	{  prg_printf("input redirected to '%s'\n", stdin_name);
	   redir = freopen ( stdin_name, "r", stdin);
	   if (redir == NULL) v_error(__FILE__, "unable to open redirected input '%s'", stdin_name);
		}
	if (spec_name)
	{  prg_printf("spec file to be seached '%s'\n", spec_name);
	   spec = fopen ( spec_name, "r");
	   if (spec == NULL) v_error(__FILE__, "unable to open spec file '%s'", spec_name);
		}
   }
/*-----------------------------------------------------------*/
int main ( int argc, char ** argv )
{   char name[200];
    enum { USE_ARGS, ASK_NAME } mode;
    long i;

#ifdef __POWERPC__
    prg_name = "bm2img";
    argc = 0;
#else
    prg_name = argv[0];
    argc--; argv++;
#endif    
    xy_chktype();
    memset(&image, 0, sizeof(IMAGE));
    d_value = f_value = i_value = NULL;
    memset(&mat_ub,0,sizeof(mat_ub));
    mat_ub.t[0]=mat_ub.t[4]=mat_ub.t[8]=1.0;
    lambda=1;
    spec_ub=0;
    memset(&goniometer,0,sizeof(goniometer));
    goniometer.pos.rx=1;
    azimuth.coord.x=azimuth.coord.y=0;
    azimuth.coord.z=1;
    azimuth_angle=90;
    r_def = ".spe";
	 if (strstr(prg_name, "spe") == prg_name) r_def = ".spe";
    if (strstr(prg_name, "edf") == prg_name) r_def = ".edf";
    if (strstr(prg_name, "gel") == prg_name) r_def = ".gel";
    if (strstr(prg_name, "txt") == prg_name) r_def = ".txt";
    prg_inifile (parameter );

    prg_printf("## %s : %s\n## %s\n## %s\n", prg_name, TITLE, RELEASE, REFERENCE);
    mode = (argc == 0) ?  ASK_NAME : USE_ARGS;
    if ( argc == 1 ) print |= 16;

    if ( d_name )
    {   get_image( d_name, NULL, &d_image );
        xy_orien(&d_image);
        d_value = cor_image ( &d_image);
        xy_freeimg (&d_image, 1);
        }
    if ( f_name )
    {   get_image( f_name, NULL, &f_image );
        f_value = cor_image ( &f_image);
        xy_freeimg (&f_image, 1);
        }
   do
   {  switch (mode)
      {  case ASK_NAME :
            fprintf(stderr, "\n [D=|F=]img_file[Bb,Ee,Aa|Mm]  name (return=end) : ");
	         buffer[0]=0;
	         fgets(buffer, sizeof(buffer)-1, stdin);
	         if ( redir ) puts(buffer);
              name[0]=0;
              sscanf(buffer," %s", name);
              if (strlen(name)== 0) continue;
              break;
           case USE_ARGS : strcpy(name, *argv);
             argc--; argv++;
	   }
     if ( name[0] == '-' ) usage("", name);
     if ( name[0] == '%' )
     {   time (&secs_now);
         str_time = ctime(&secs_now);
         prg_printf ("\n# %s# command : %s\n", str_time, name);
         switch (name[1])
         {  case 'X' : case 'Y' :
            case 'Z' : put_image( name+1, out, &image);  break;
            case 'M' : mul_image( name+2, &image);  break;
            case 'A' : add_image( name+2, &image);  break;
            case 'C' : cut_image( name+2, &image);  break;
            case 'S' : sca_image( name+2, &image);  break;
            case 'R' : radial( name+2, out, &image);  break;
            case 'P' : peaks( name+2, out, &image);  break;
            case 'H' : hkl_map( name+2, out, &image);  break;
            case 'F' : xy_freeimg (&image, 2);  break;
            case 'G' : grid_image (name+2, &image);  break;
            case 'g' : excl_save (name+2, &image);  break;
            case 'T' : transfo_image (name+2, &image);  break;
            default  : if ( USE_ARGS) v_error(__FILE__, "unknown command '%s'", name);
                       fprintf(stderr, "unknown command '%s'", name);
            }
         if ( strchr("XYZRPF", name[1])==NULL && print & 4)
         {  xy_info(&image, 0);
            xy_fputinfo( stdout, &image);
            }
         } else
     if ( strstr( name, "D=") == name )
     {   if (d_name) FREE (d_name);
         xy_freeimg(&d_image, 2);
         d_value = NULL;
         if (strcmp(name,"NONE") == 0 ) continue;
         d_name = malloc ( strlen(name));
         strcpy(d_name, name+2);
         if (d_value) FREE (d_value);
         get_image( d_name, dir, &d_image );
         xy_orien(&d_image);
         d_value = d_image.data;
         xy_freeimg (&d_image, 1);
         if (d_value) prg_printf("# Dark set to : %s\n", d_name);
         } else
     if ( strstr( name, "F=") == name )
     {   if (f_name) FREE (f_name);
         xy_freeimg(&f_image, 2);
         f_value = NULL;
         if (strcmp(name,"NONE") == 0 ) continue;
         f_name = malloc ( strlen(name));
         strcpy(f_name, name+2);
         if (f_value) FREE (f_value);
         get_image( f_name, dir, &f_image );
         f_value = f_image.data;
         xy_freeimg (&f_image, 1);
         if (f_value) prg_printf("# Flat field set to : %s\n", f_name);
         } else
     {   if (i_name) FREE (i_name);
         i_name = malloc ( strlen(name)+1);
         strcpy(i_name, name);
         if (i_value) FREE (i_value);
         get_image( i_name, dir, &i_image);
			excl_image ( &i_image, print );
         xy_orien(&i_image);
			if ( strstr(prg_name, "stat") ) 
			{   if (set_limit==2) bm_stat( &i_image, d_value, &d_image, set_limit, low_limit, print);
			    else  bm_stat( &i_image, d_value, &d_image, set_limit, 0, print);
				 }
         else proc_image ( &i_image );
         }
     } while( (mode == ASK_NAME && name[0] != 0)
                || ( mode == USE_ARGS && argc != 0));
      PRG_EXIT
      return 0;
      }
/*-----------------------------------------------------------*/
void proc_image ( IMAGE *img)
{   long i, j;
    double rho;

    i_value = img->data;
    img->cosmic.sum_corrected = 1; /* no more influence of correction cf CRochas using ,X => info errors sep03 */
	 if ( d_value )
    {   rho = img->used_frames / (double) d_image.used_frames;
        for (i=0; i<img->size; i++) i_value[i] -= rho * d_value[i];
        }
    if (add_dark)  for (i=0; i < img->size; i++) i_value[i] -= add_dark;
    grid_done = 0;
    if (grid_auto && strcmp(grid_auto,"AUTO")==0)  grid_image ("", img);
    if ( print & ( 8 || 32 ) && ( d_value || add_dark || low_limit || f_value|| grid_done ) )
    {    if ( print &  32 && img->size < XY_PRINTSIZE ) xy_val_dump ( img, stdout, "#R");
         xy_info(img, 0);
         prg_printf("# %s : corrected (dark=%s,flat=%s,grid=%s) and %d pixel(s) corrections (s=%d,t=%d,s=%d,l=%d)\n", img->name,
               d_value ? d_image.name : "", f_value ? f_image.name : "",grid_done ? "auto":"none",
               img->cosmic.saturated+img->cosmic.t_number+img->cosmic.s_number+img->cosmic.l_number,
               img->cosmic.saturated, img->cosmic.t_number, img->cosmic.s_number, img->cosmic.l_number);
         xy_fputinfo( stdout, img);
         }
    if ( f_value )
    {   rho = f_image.info.mean;
        for (i=0; i<img->size; i++) if ( f_value[i] != 0 ) i_value[i] *= rho / f_value[i];
        }
   if (set_limit) 
   {  int n;
      double mean;
      for (i=0; i < img->size; i++)
      if ( i_value[i] <= low_limit ) 
      {  /* mean = xy_vmean(img, i, -1,1,-1,1, &n, NULL) + .5; 
           if ( n> 1) mean = ( n * mean - i_value[i] ) / (n-1);  changed 17/12/02 */
		   mean = xy_condmean(img, i, -1,1,-1,1, &n, low_limit) + .5;
         if (set_limit == 2) i_value[i] = low_limit; 
			else i_value[i] = ( mean > low_limit ) ? mean : low_limit; 
         img->frame[i] = 0;
         img->cosmic.l_number++;
         }
       }
    if (image.data)
    {   COUNTS * value = image.data;
        FRAMES * frame = image.frame;
        image.used_frames += img->used_frames;
        for (i=0; i < image.size; i++) value[i] += i_value[i];
        for (i=0; i < image.size; i++) frame[i] += img->frame[i];
        prg_printf("\n# adding image %s to %s\n", img->name, image.name );
        xy_freeimg( img, 2 );
        i_value = NULL;
        i_name = NULL;
        xy_info(&image, 0);
        xy_fputinfo( stdout, &image);
        }
    else
    {   image = *img;
        prg_printf("\n# base image %s -> %s (%s)\n", img->name, image.name, i_name);
        /* i_name = NULL; */
        i_value = NULL;
        }
    }      
/*-----------------------------------------------------------*/
void get_image ( char * name, char *path, IMAGE *img)
{  int  i, rep, rep_size, repeat = 1;
   int  iname = -1;
   int  used_frames = -1;
   ADD_MERGE rep_mode = ADD_IMG;
   char *c, *d, *e, bname[200], ename[20], cname[200];
   COUNTS *value, *rep_value;
   FRAMES *frame;
   XY_HDR *hdr;
   FILE *chk;
   char chk_str[81];
   int  do_stat; 
   int  dont_cor = 0;
   int  sum_frames = 0;
	int  df = 0;
   xy_imgini ( img, &image);
	repeat = xy_rep_name( name, img, bname, ename, &df, &iname, 
	           &dont_cor, &used_frames, &rep_mode);

   do_stat = img->cosmic.time>0 || strstr(prg_name, "stat");
   if ( rep_mode == MERGE_IMG || dont_cor ) do_stat = 0;

   for (rep = 0; rep < repeat; rep++, iname++)
   {  prg_printf( "\n");
		xy_cur_name(buffer, path, bname, ename, df, iname);
	   c = malloc(strlen(buffer)+1);
	   strcpy (c, buffer);
      img->name = c;
      hdr = xy_open (buffer, prg_name, 0, r_def, real_time, 1); 
      if ( o_cosmic && strstr(o_cosmic, "STDOUT" )) out_cosmic = stdout;
      else if ( print & 256+128+64 )
      {   char o_name[200];
          prg_outname(o_name, o_cosmic, buffer, ".cosmic", out);
          out_cosmic = fopen(o_name, "w");
          }   

	    if (df && df != dformat )
		 {  FREE(img->name);
		    sprintf(cname, "%s%0*d%s", bname, dformat, iname, ename);
          if (path && path[0] && bname[0]!='/' && bname[0]!='.')
          {    strcpy( buffer, path);
              if (buffer[strlen(buffer)-1] != '/') strcat(buffer,"/");
            } else buffer[0]=0;
	       strcat (buffer, cname );
	       c = malloc(strlen(buffer)+1);
	       strcpy (c, buffer);
          img->name = c;
		    }
       img->header = hdr;
       xy_puthdr( hdr, print & 16 );
       if ( out_cosmic) rep_value = xy_getsum(img, out_cosmic, print, rep == 0, do_stat );
       else rep_value = xy_getsum(img, stdout, print, rep == 0, do_stat );
		 sum_frames += img->used_frames;
/*       img->used_frames = sum_frames;  done in xy_getsum 29-3-00 */
       xy_info(img, 0);
       xy_fputinfo( stdout, img);
       if ( repeat > 1)
       {   if (rep == 0)
           {   rep_size = img->size;
               if (rep_mode == MERGE_IMG )
               {   value = (COUNTS *) malloc(repeat*rep_size*sizeof(COUNTS));
                   frame = (FRAMES *) malloc(repeat*rep_size*sizeof(FRAMES));
                   if (value== NULL || frame==NULL) V_ERROR("allocating whole image memory");
                   }
               }
           if (rep_mode == MERGE_IMG ) 
           {   memcpy(value+rep*rep_size, rep_value, sizeof(COUNTS)*rep_size);
               memcpy(frame+rep*rep_size, img->frame, sizeof(FRAMES)*rep_size);
               memset(rep_value, 0, sizeof(INT32)*rep_size);
               }
           if (rep+1 != repeat) xy_freehdr(hdr);
			  else if (hdr->file) { fclose(hdr->file); hdr->file=NULL; }
           }
       else img->data = rep_value;
       }
   if ( repeat > 1)
   {   if (rep_mode == ADD_IMG )
       {   img->data = rep_value;
           }
       else  /* if (rep_mode == MERGE_IMG ) */
       {   img->size *= repeat;
           img->y_size *= repeat;
           img->data = value;
           img->frame=frame;
           prg_printf( "\n# new image  %d * %d = %d\n",
                   img->x_size, img->y_size, img->size);
           }
       }
    if (dont_cor) prg_printf("# No cosmic corrections are applied\n");
    else cor_image (img);  
   if (img->used_frames > 1 )
	{  float ratio;
	   for (i=0; i<img->size; i++) 
		 if (img->frame[i] != 0 && img->frame[i] != img->used_frames)
       {   ratio = img->used_frames / img->frame[i];
		     img->data[i] = 0.5 + img->data[i] * ratio;
           }
		 }
    if (used_frames > 0)
	 {  prg_printf("# frames number %d modified to %d\n", img->used_frames, used_frames); 
	    img->used_frames = used_frames;
		 }
    }
/*-----------------------------------------------------------*/
INT32 * cor_image( IMAGE *img)
{  int i, j, k, nt =0;
   int used_frames = img->used_frames;
   COUNTS  * val = img->data;
   FILE * outf = NULL;
   FRAMES *frame = img->frame;
   double *sumq = img->cosmic.sumq;
   outf =  ( out_cosmic ) ? out_cosmic : stdout;
   if (outf && print & 256 && img->tsize < XY_PRINTSIZE)  xy_sum_dump (img, outf, "#T(N)");
   if (sumq && used_frames > 3 && img->cosmic.time > 0) 
   {   if (outf && print & 256 && img->tsize < XY_PRINTSIZE)   xy_sta_dump (img, outf, "#M(S)"); 
       if ( print & 64 ) xy_tcosmic( img, outf );
        else  xy_tcosmic( img, NULL );
       if ( print & 4 )
       prg_fprintf(outf, "# %d cosmic(s) found using time series (t=%5.1f, h=%5.1f)\n",
              img->cosmic.t_number, img->cosmic.time, img->cosmic.t_height);
       if ( img->cosmic.t_number && outf && print & 256 && img->tsize < XY_PRINTSIZE) 
       {   xy_sum_dump (img, outf, "#T(N)");
           xy_sta_dump (img, outf, "#M(S)"); 
           }
        }
   if ( strstr(prg_name, "stat") != NULL ) return img->data;
	for (i=0; i<img->size; i++) if (img->frame[i] != 0 && img->frame[i] != used_frames)
   {   nt++;
       val[i] = 0.5 + (val[i] * used_frames ) /( img->frame[i]);
       }
   img->cosmic.sum_corrected = 1;
   if (print & (8  || 128)) prg_fprintf(outf, "# %d pixel(s) corrected\n", nt);
   if ( outf && nt && print & 128 && img->size < XY_PRINTSIZE ) xy_val_dump (img, outf, "#C");
   if ( img->cosmic.space > 0 && img->cosmic.s_height > 0 ) 
   {   if ( print & 64 ) xy_space( img, outf );
       else  xy_space( img, NULL );
       if  ( print & (8||32||128) ) prg_fprintf(outf, "# %d cosmic(s) or hot_spot(s) found on spatial means (s=%5.1f, p=%5.1f), corrected\n",
              img->cosmic.s_number, img->cosmic.space, img->cosmic.s_height);
       if ( img->cosmic.s_number && outf && print & 256 && img->tsize < XY_PRINTSIZE) 
       {   xy_sum_dump (img, outf, "#T(N)");
           xy_sta_dump (img, outf, "#M(S)"); 
           }
       if ( img->cosmic.s_number && outf&& print & 128 && img->size < XY_PRINTSIZE ) xy_val_dump (img, outf, "#C");
       }
      if (nt && ( print & (8||128) ))
      {   prg_fprintf(stdout,"# after corrections s=%d, t=%d, s=%d\n",img->cosmic.saturated, img->cosmic.t_number,img->cosmic.s_number);
		    xy_info(img, 0);
          xy_fputinfo( stdout, img);
        if (out_cosmic && out_cosmic != stdout)
        {   prg_fprintf(out_cosmic,"# after corrections s=%d, t=%d, s=%d\n",img->cosmic.saturated, img->cosmic.t_number,img->cosmic.s_number);
            xy_fputinfo( out_cosmic, img);
		}
 	  }
   xy_freeimg (img, 0);
   return img->data;    
   }
/*-----------------------------------------------------------*/
void put_image ( char * name, char *path, IMAGE *img)
{   char *c, *n, b[200], e[200];
    int dyn = 0;
    if (img->data == NULL) V_ERROR("no data to write");
    switch ( name[0])
    {  case 'X' : dyn=0; break;
       case 'Y' : dyn=1; break;
       case 'Z' : dyn=2; break;
       }
    name++;
    if ( *name == '=' ) name++;
    prg_outname( b, name, img->name, NULL, path);
    c = img->name;
    img->name = b;
    if ( *name == 0 || *name == '.' || strstr(name+1,".") == NULL )
    {  if ( d_name ) strcat(b, "d");
       if ( f_name ) strcat(b, "f");
       if ( grid_done ) strcat(b, "g");
       }
    /* trying to avoid overwriting edf img */
	 strcpy(e, c);
    n = strchr(e, '.'); 
    if (n) *n=0;
    if ( strlen(name)==0 && strstr(c, ".edf") && strcmp(e, b) == 0 )
	      strcat(b,"_x");
    if ( strstr(name, ".gel") )   gel_write(img, ".gel", dyn) ;
    else if ( strstr(name, ".tif") )    gel_write(img, ".tif", dyn);
    else if ( strstr(name, ".txt") )    txt_write(img);
    else   edf_write(img, t_mode);
    img->name = c;
/*    if  (dyn == 0 ) xy_freeimg( img, 2); */
    }
/*-----------------------------------------------------------*/
void add_image ( char * name, IMAGE *img)
{   COUNTS *v;
    double c;
    int i;
    if (img->data == NULL) V_ERROR("no data to process");
    if (name[0]=='=' ) name++;
    v = img->data;
	 if (strstr(name,"SPEC")) {
		 c = spec2xl(name, img);
		 }
    else c = atof(name);
    printf(" adding %lg to counts on image\n", c);
    for ( i=0; i < img->size; i++) v[i] = c+v[i];
    }
/*-----------------------------------------------------------*/
void mul_image ( char * name, IMAGE *img)
{   INT32 *v;
    double c;
    int i;
    if (img->data == NULL) V_ERROR("no data to process");
    if (name[0]=='=' ) name++;
    v = img->data;
	 if (strstr(name,"SPEC")) {
		 c = spec2xl(name, img);
		 }
    else c = atof(name);
    printf(" multiplying counts on image by %lg\n", c);
    for ( i=0; i < img->size; i++) v[i] = c*v[i];
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void cut_image ( char * name, IMAGE *img)
{   COUNTS *v, c;
    double d;
    int i;
    if (img->data == NULL) V_ERROR("no data to process");
    xy_info(img,8);
    if (name[0]=='=' ) name++;
    v = img->data;
    if (name[0] != ',' )
    {  d = atof(name);
       c = d * img->info.mean;
       prg_printf("# truncating values higher than  to %d=%.1lf*%.1lf(=mean)\n", c, d, img->info.mean);
       for ( i=0; i < img->size; i++) if (v[i] > c ) v[i] = c;
       while  ( name[0] && name[0] != ',' ) name++;
       if (name[0] == 0) return;
       }
    name++;
    if (name[0] == 0) return;
    d = atof(name);
    c = d * img->info.mean;
    prg_printf("# truncating values lower than  to %d=%.1lf*%.1lf(=mean)\n", c, d, img->info.mean);
    for ( i=0; i < img->size; i++) if (v[i] < c ) v[i] = c;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void sca_image ( char * name, IMAGE *img)
{   COUNTS *v;
    double c, d;
    int i;
    if (img->data == NULL) V_ERROR("no data to process");
    xy_info(img,4);
    if (name[0]=='=' ) name++;
    v = img->data;
    d = atof(name);
    c = d * img->info.maxi;
    prg_printf("# rescaling %lf : %d(=maxi) to %.0lf\n", d, img->info.maxi, c);
    for ( i=0; i < img->size; i++) v[i] *= d;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void grid_image ( char * name, IMAGE *img)
{   if (img->data == NULL) V_ERROR("no data to process");
    if (grid_done) V_ERROR("grid correction soon applied");
    if (g_name==NULL) g_name  = "GRID_AUTO";
    grid_cor_img (&grid_cor, img, 1);
    grid_done=1;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
double spec2xl( char * name, IMAGE *img)
{  double a,b,c;
   char *d;
	char cmd[200];
	char fname[100];
	char tname[100];
	FILE *f;
	int i, n;
	a=0;
	sscanf(name,"%lf", &a);
	strcpy(fname, img->name);
	if (d=strchr(fname,'.')) *d=0;
	if ( d=strrchr(fname,'/')) d+=1; else d=fname;
	sprintf(tname,"%s.SPEC",prg_name);
	unlink(tname);
	if ((d=strrchr(wspec2xl,'*')))
	{   *d=0;
	    sprintf(cmd,"%s%s%s %s >%s",wspec2xl, fname, d+1, spec_name,tname);
       printf ("# running(*) '%s'\n",cmd);
		 *d='*';
		 }
	else
	{   sprintf(cmd,"%s%s %s >%s",wspec2xl, fname, spec_name,tname);
       printf ("# running '%s'\n",cmd);
		 }
	system(cmd);
	f=fopen(tname,"r");
	while( !feof(f) )
	{   fgets(fname,199,f);
	    if (fname[0]=='#') continue;
		 }
	fclose(f);
	d=fname;
	for( i=0; i<=xl_col;i++)
	{  sscanf(d," %s%n", &tname, &n);
	   d+=n;
	   } 
	sscanf(tname,"%lf", &b);
	if (strstr(name,"/SPEC")) c = a/b;
	else if (strstr(name,"*SPEC")) c = a*b;
	else if (strstr(name,"+SPEC")) c = a+b;
	else if (strstr(name,"-SPEC")) c = a-b;
	else c=b;
	printf("# using %.4lg/%.4lg=%.6lg as coefficient\n",a,b, c );
	return c;
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* void spec_image (char *name); */
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

